#include <string>

#include <cstdlib>

#include <mem.h>

template<typename T>
static inline T* not_null(T* ptr)
{
	if(!ptr) throw "TODO: Nullptr except";
	return ptr;
}

namespace mem
{
	void* aligned_ptr<void >::_alloc(usize a, usize s) { return not_null<void>( aligned_alloc(a, s) ); }
	void aligned_ptr<void >::_dealloc(void* ptr) { free(ptr); }
}

void test()
{
	auto ptr = mem::make_aligned<std::string>("hello");
	auto len = ptr->size();

	printf("Stirng: %s, %lu\n", ptr->c_str(), (usize)len);
}
